<!-- MemoryUpgrade.js -->
<!-- Copyright (C) 2000-2002  Intel Corporation -->

<SCRIPT>
	/* Defines */
	var	MAXMEMORYSLOTS = 8;
	var	MAXTEXTOPTIONS = 3;
	var	MEMORYSINGLE = 0;
	var	MEMORYPAIRED = 1;
	
	var	MEMOPTIONUSED = 1;
	var	MEMOPTIONEMPTY = 2;
	var	MEMOPTIONSIMM = 4;
	var	MEMOPTIONDIMM = 8;
	var MEMOPTIONRIMM = 16;
	var MEMOPTIONDDR = 32;
	var MEMOPTIONSODIMM = 64;

/* Min Memory Type sizes */
	var	MINSIMMSIZE = 4;
	var	MINDIMMSIZE = 16;
	var MINSODIMMSIZE = 32;
	var MINRIMMSIZE = 64;
	var MINDDRSIZE = 128;

	var	TRUE = 0;
	var	FALSE = 1;

	/* Global Variables */
	var m_dwSlotOptions = new Array(MAXMEMORYSLOTS);
	var	m_dwSlotMemorySize = new Array(MAXMEMORYSLOTS);
	var	m_dwMaxSlotSize = new Array(MAXMEMORYSLOTS);

	var	MemoryUpgradeArray = new Array();

	var	m_nEmptySlots = 0;
	var	m_nCurrentPhysicalMemorySize = 0;
	m_nMaximumPhysicalMemorySize = new Array();
	var	m_nMemoryBankConnection = 0;
	var	m_csMemUpgradeOptions = "";
	var	m_csMemUpgradeOptionsTotal = "";

	/* DAC Variables */
	var	DACMaxSIMMSize = 64;
	var	DACMaxSODIMMSize = 4096;
	var	DACMaxDIMMSize = 4096;
	var	DACMaxRIMMSize = 4096;
	var	DACMaxDDRSize = 4096;

	/* Text Variables */
	m_csNA = "<STR ID=strMemUpNa>";
	m_csTransTextSimm = "<STR ID=strMemUpSIMM>";
	m_csTransTextDimm = "<STR ID=strMemUpDIMM>";
	m_csTransTextSODIMM = "SODIMM";
	m_csTransTextRIMM = "<STR ID=strMemUpRIMM>";
	m_csTransTextDDR = "<STR ID=strMemUpDDR>";
	m_csTransTextOption = "<STR ID=strMemUpOption>";
	m_csTransTextMegabyte = "<STR ID=strMemUpMegabyte>";
	m_csTransTextDoubleSidedS = "<STR ID=strMemUpDoubleSidedMemoryModule>";
	m_csTransTextDoubleSidedP = "<STR ID=strMemUpDoubleSidedMemoryModules>";
	m_csTransTextSingleSidedS = "<STR ID=strMemUpSingleSidedMemoryModule>";
	m_csTransTextSingleSidedP = "<STR ID=strMemUpSingleSidedMemoryModules>";
	m_csTransTextEmptyMemorySlot0 = "<STR ID=strMemUpLeavingSlot0>";
	m_csTransTextEmptyMemorySlotS = "<STR ID=strMemUpLeavingSlotS>";
	m_csTransTextEmptyMemorySlotP = "<STR ID=strMemUpLeavingSlotP>";
	m_csTransTextUpgradeThisComputer = "<STR ID=strMemUpUpgradeThisComputerTo>";
	m_csTransTextTheseOptionsWill = "<STR ID=strMemUpTheseOptionsWillUpgrade>";
	m_csTransTextAdd = "<STR ID=strMemUpAdd>";

</SCRIPT>

<SCRIPT>
function SetupMemoryVariables()
{
	var			i = 0;
	var			nSize = 0;
	var			csBankConnection = "";
	var			nMaxSIMMSize = 0;
	var			nMaxDIMMSize = 0;
	var			nMaxSODIMMSize = 0;
	var			nMaxRIMMSize = 0;
	var			nMaxDDRSize = 0;

	/* Clear Variables */
	for (i = 0; i < MAXMEMORYSLOTS; i++) {
		m_dwSlotOptions[i] = 0;
		m_dwSlotMemorySize[i] = 0;
	}

	/* Get the Number of Memory Slots */
	m_nMemorySlots = DACNumberOfMemorySlots;

	/* Make sure this is ok */
	if (m_nMemorySlots <= 0 || m_nMemorySlots > MAXMEMORYSLOTS) {
		return(FALSE);
	}

	/* Setup nMaxSIMMSize */
	nMaxSIMMSize = DACMaxSIMMSize;

	/* Setup nMaxDIMMSize */
	nMaxDIMMSize = DACMaxDIMMSize;

	/* Setup nMaxSODIMMSize */
	nMaxSODIMMSize = DACMaxSODIMMSize;

	/* Setup nMaxRIMMSize */
	nMaxRIMMSize = DACMaxRIMMSize;

	/* Setup nMaxDDRSize */
	nMaxDDRSize = DACMaxDDRSize;

	m_nEmptySlots = 0;
	m_nCurrentPhysicalMemorySize = 0;
	csBankConnection = "";

	/* Grab the Bank Connection Text */
	csBankConnection = DACBankConnections[0];

	/* Default to Single */
	m_nMemoryBankConnection = MEMORYSINGLE;

	/* Figure out if each slot is empty or used and if the bank connection should be paired or single */
	for (i = 0; i < m_nMemorySlots; i++) {
		nSize = DACEnabledSize[i];
		/* Is it Empty? */
		if (nSize == 0) {
			/* Yes */
			m_dwSlotOptions[i] |= MEMOPTIONEMPTY;
			m_nEmptySlots++;
		}
		else {
			m_dwSlotOptions[i] |= MEMOPTIONUSED;
			m_nCurrentPhysicalMemorySize += nSize;
		}

		/* Determine if this slot uses DDR, RIMM, DIMMs or SIMMs */
		/* NOTE: DACCurrentMemoryType[i] and m_csTransTextSimm should be lowercased to be safe */

		/* Was there a match? */
		if (DACCurrentMemoryType[i].search(m_csTransTextDDR) != -1){
			/* NO, its a DDR */
			m_dwSlotOptions[i] |= MEMOPTIONDDR;
			m_dwMaxSlotSize[i] = nMaxDDRSize;
		}
		else if (DACCurrentMemoryType[i].search(m_csTransTextSODIMM) != -1){
			/* NO, its a DIMM */
			m_dwSlotOptions[i] |= MEMOPTIONSODIMM;
			m_dwMaxSlotSize[i] = nMaxSODIMMSize;
		}
		else if (DACCurrentMemoryType[i].search(m_csTransTextDimm) != -1){
			/* NO, its a DIMM */
			m_dwSlotOptions[i] |= MEMOPTIONDIMM;
			m_dwMaxSlotSize[i] = nMaxDIMMSize;
		}
		else if (DACCurrentMemoryType[i].search(m_csTransTextRIMM) != -1){
			/* NO, its a RIMM */
			m_dwSlotOptions[i] |= MEMOPTIONRIMM;
			m_dwMaxSlotSize[i] = nMaxRIMMSize;
		}
		else if (DACCurrentMemoryType[i].search(m_csTransTextSimm) != -1){
			/* Yes, its a SIMM */
			m_dwSlotOptions[i] |= MEMOPTIONSIMM;
			m_dwMaxSlotSize[i] = nMaxSIMMSize;
		}
		else if (i > 0){
			m_dwSlotOptions[i] |= m_dwSlotOptions[i-1];
			m_dwMaxSlotSize[i] = m_dwMaxSlotSize[i-1];
		}
		else if (i == 0){
			m_dwSlotOptions[i] |= 0;	// unknown option
			m_dwMaxSlotSize[i] = 0;		// unknown size, probably not upgradeable
		}

		m_dwSlotMemorySize[i] = nSize;

		/* Is the Bank Connection text the same? Determine if Paired or Single */
		if (DACBankConnections[i] != csBankConnection) {
			/* No, Set to Single */
			m_nMemoryBankConnection = MEMORYSINGLE;
		}
		else {
			/* Yes, Set to Paired */
			m_nMemoryBankConnection = MEMORYPAIRED;
		}

		/* Save current Bank Connection */
		csBankConnection = DACBankConnections[i];
	}

	<MND MODULE="INTEL/DMI">
		<PARAM NAME="CGEF" VALUE="Intel|Memory Pairing|001"/>
		<PARAM NAME="FSTR" VALUE="var iForce = %ATTR(1)%;">
	</MND>

	<MND MODULE="INTEL/DMI">
		<PARAM NAME="CGEF" VALUE="DMTF|Physical Memory Array|"/>
		<PARAM NAME="FLTR" VALUE="%ATTR(3)==3%"/>
		<PARAM NAME="TABL" VALUE="LIST"/>
		<PARAM NAME="FSTR" VALUE="m_nMaximumPhysicalMemorySize[%ROW0%] = %ATTR(4)% / 1024;">
	</MND>


	for (var i = 0; i < m_nMaximumPhysicalMemorySize.length; ++i)
	{
		if (0 == m_nMaximumPhysicalMemorySize[i])
		{
			m_nMaximumPhysicalMemorySize[i] = 1024;
		}
	}


	if (iForce == 1)
		m_nMemoryBankConnection = MEMORYPAIRED;

	/* Create Memory Upgrade Option */
	CreateMemoryUpgradeOptions();
	return(TRUE);
}


function CreateMemoryUpgradeOptions()
{
	var		i = 0;
	var		j = 0;
	var		nStartAt = 0;
	var		dwSlots = new Array(MAXMEMORYSLOTS);
	var		nTotal = 0;
	var		dwTemp = 0;
	var		nAdjustBottom = 0;

	/* Do we have any empty memory slots */
	if (m_nEmptySlots == 0) {
		/* Nope, just leave */
		return;
	}

	/* Clear Variables */
	for (i = 0; i < MAXMEMORYSLOTS; i++) {
		dwSlots[i] = 0;
	}

	for (i = 0; i < MAXMEMORYSLOTS; i++)
	{
		/* Is this an empty slot? */
		if (m_dwSlotOptions[i] & MEMOPTIONEMPTY)
		{
			/* Yes, Is this slot a SIMM or DDR or SODIMM or DIMM or RIMM */
			if (m_dwSlotOptions[i] & MEMOPTIONDDR)
			{
				/* DDR */
				nStartAt = MINDDRSIZE;
				/* Leave */
				i = MAXMEMORYSLOTS;
			}
			else if (m_dwSlotOptions[i] & MEMOPTIONDIMM)
			{
				/* DIMM */
				nStartAt = MINDIMMSIZE;
				/* Leave */
				i = MAXMEMORYSLOTS;
			}
			else if (m_dwSlotOptions[i] & MEMOPTIONRIMM)
			{
				/ * RIMM */
				nStartAt = MINRIMMSIZE;
				/ * Leave */
				i = MAXMEMORYSLOTS;
			}
			else if (m_dwSlotOptions[i] & MEMOPTIONSODIMM)
			{
				/ * SODIMM */
				nStartAt = MINSODIMMSIZE;
				/ * Leave */
				i = MAXMEMORYSLOTS;
			}
			else
			{
				/ * SIMM */
				nStartAt = MINSIMMSIZE;
				/ * Leave */
				i = MAXMEMORYSLOTS;
			}
		}
	}
	m_csMemUpgradeOptions = "";
	m_csMemUpgradeOptionsTotal = "";

	/* Is this Single banked Memory? */
	if (m_nMemoryBankConnection == MEMORYSINGLE) {
		/* Yes, Single, Fill in the slots with memory sizes */
		for (i = 0; i < m_nEmptySlots; i++) {
			/* set Everything to Zero */
			dwSlots[i] = 0;
		}
		/* Make the last Item the starting point */
		dwSlots[(m_nEmptySlots - 1)] = nStartAt;
	}
	else {
		/* No, Paired, Fill in the slots with memory sizes */
		/* Are there more that 2 Empty Slots? */
		if (m_nEmptySlots > 2) {
			/* Yes */
			i = m_nEmptySlots;
			i--;
			dwSlots[i] = nStartAt;
			i--;
			dwSlots[i] = nStartAt;
		}
		else {
			/* No */
			for (i = 0; i < m_nEmptySlots; i++) {
				dwSlots[i] = nStartAt;
			}
		}
	}

	var nTotalPhysicalMemorySize = 0;

	for (i = 0; i < m_nMaximumPhysicalMemorySize.length; ++i)
	{
		nTotalPhysicalMemorySize += m_nMaximumPhysicalMemorySize[i];
	}

	for (i = 0; i < m_nMaximumPhysicalMemorySize.length; ++i)
	{
		while (dwSlots[i] <= m_dwMaxSlotSize[i])
		{
			/* Figure out the total size of the empty slots */
			for (nTotal = 0, j = 0; j < m_nEmptySlots; j++) {
				nTotal += dwSlots[j];
			}
			/* Add the current physical memory size */
			nTotal += m_nCurrentPhysicalMemorySize;

			if (nTotal > nTotalPhysicalMemorySize)
				break;

			/* Now, write the total into csMemUpgradeOptionsTotal */
			m_csMemUpgradeOptionsTotal += nTotal;
			m_csMemUpgradeOptionsTotal += ","; //localization OK

			/* Now write this the Memory Upgrade options to csMemUpgradeOptions */
			for (j = 0; j < m_nEmptySlots; j++) {
				m_csMemUpgradeOptions += dwSlots[j];
				m_csMemUpgradeOptions += ","; //localization OK
			}


			/* Should this memory module be paired */
			if (m_nMemoryBankConnection == MEMORYPAIRED) {
	/**********/
	/* Paired */
	/**********/		
				/* Yes, Have we reached the limit? */
				if (dwSlots[0] != m_dwMaxSlotSize[0]) {
					nAdjustBottom = 0;
					/* Shift memory option to the next level. 4 meg to 8 meg to 16 meg, etc.. */
					for (j = (m_nEmptySlots - 1); j >= 0; j--) {
						dwTemp = dwSlots[j];
						/* have we reached the limit? */
						if (dwTemp != m_dwMaxSlotSize[j]) {
							/* No, */
							if (dwTemp == 0) {
								dwTemp = nStartAt;
							}
							else {
								/* Times it by 2 */
								dwTemp = (dwTemp * 2);
							}
							/* save the New Value */
							dwSlots[j] = dwTemp;
							/* do the other slot */
							dwSlots[j - 1] = dwTemp;
							/* Do we need to adjust the bottom ones? */
							if (nAdjustBottom != 0) {
								/* Yes, */
								do {
									j++;
									dwSlots[j] = dwTemp;
									nAdjustBottom--;
								} while (nAdjustBottom > 0);
							}
							
							/* Leave */
							j = 0;
						}
						else {
							nAdjustBottom++;
						}
					}
				}
				else {
					/* Force a break out */
					dwSlots[0] = (m_dwMaxSlotSize[0]) + 1;
				}
			}
	/**********/
	/* Single */
	/**********/
			else {
				/* Yes, Have we reached the limit? */
				if (dwSlots[i] != m_dwMaxSlotSize[i]) {
					/* No, Proceed */
					/* Shift memory option to the next level. 4 meg to 8 meg to 16 meg, etc.. */
					for (j = (m_nEmptySlots - 1); j >= 0; j--) {
						dwTemp = dwSlots[j];
						/* have we reached the limit? */
						if (dwTemp > m_dwMaxSlotSize[j] ) {	/* matsumoto fixed at 10/1/1999. */
							dwSlots[j] = dwTemp-dwTemp/4;
							dwTemp = m_dwMaxSlotSize[j];
							j = 0;
						}
						else if (dwTemp < m_dwMaxSlotSize[j]) {
							/* No, Times it by 2 */
							dwTemp = (dwTemp * 2);
							/* save the New Value */
							dwSlots[j] = dwTemp;
							/* Leave */
							j = 0;
						}
						else {
							/* Yes, */
							/* Grab the previous value */

							if (j != 0) {
								j--;
							}
							dwTemp = dwSlots[j];
						TryAgain:
							if (dwTemp == 0) {
								dwTemp = nStartAt;
							}
							else {
								if (j != 0) {
									if (dwTemp == m_dwMaxSlotSize[j]) {
										j--;
										dwTemp = dwSlots[j];

										/* Times it by 2 */
										dwTemp = (dwTemp * 2);

										if (dwTemp == 0) {
											dwTemp = nStartAt;
										}

										break TryAgain;
									}
								}
								/* Times it by 2 */
								dwTemp = (dwTemp * 2);
							}

							/* Write in the rest of the slots */
							do {
								dwSlots[j] = dwTemp;
								j++;
							} while (j < m_nEmptySlots);
							/* Leave */
							j = 0;
						}
					}
				}
				else {
					/* Yes, Force a break out */
					dwSlots[i] = (m_dwMaxSlotSize[i]) + 1;
				}
			}
		}
	}
}

function GetNumberOfMemoryUpgradeOptions()
{
	var				i = 0;
	var				j = 0;
	var				nLen = 0;
	var				nTotal = 0;
	var				nArrayTotal = 0;
	var				nNum = 0;
	var				nRet = 0;

	nTotal = 0;
	
	/* Get the length of this string */
	nLen = m_csMemUpgradeOptionsTotal.length;

	/* Do we have anything? */
	if (nLen == 0) {
		/* No, Just return zero */
		return nTotal;
	}

	/* Find the total number of memory options */
	for (i = 0; i < nLen; i++) {
		if (m_csMemUpgradeOptionsTotal.charAt(i) == ',') {
			nTotal++;
		}
	}

	/* Create a sorted array of Memory Upgrade Options */
	/* Clear the Array */
	MemoryUpgradeArray = new Array();

	for (i = 0; i < nTotal; i++) {
		nNum = parseInt(GetMemoryUpgradeOptionsByIndex(i), 10);

		/* Do the array sort dance */
		nArrayTotal = MemoryUpgradeArray.length;
next:
		for (j = 0; j < nArrayTotal; j++) {
			nRet = MemoryUpgradeArray[j];
			/* Is this new Item Less than or equal to the item in the array */
			if (nNum <= nRet) {
				if (nNum != nRet) {
					/* Only Insert in to the Memory Upgrade Array before the item if not equal */
					MemoryUpgradeArray[j] =  nNum;
				}
				/* Leave */
				i++;
				nNum = parseInt(GetMemoryUpgradeOptionsByIndex(i), 10);
				/* Do the array sort dance */
				nArrayTotal = MemoryUpgradeArray.length;
				break next;
			}
		}
		/* Insert the item at the very end of the array */
		MemoryUpgradeArray[nArrayTotal] = nNum;
	}

	/* Now get the real size */
	nTotal = MemoryUpgradeArray.length;
	return nTotal;
}


function GetMemoryUpgradeOptionsByIndex(nIndex)
{
	var		i = 0;
	var		nLen = 0;
	var		csNumber = "";
	var		nTotal = 0;

	/* Get the length of this string */
	nLen = m_csMemUpgradeOptionsTotal.length;

	/* Is the upgrade string empty? */
	if (nLen == 0) {
		/* Yes, Return an Error */
		return 0;
	}

	/* Empty it */
	csNumber = "";
	nTotal = 0;

	/* Find the total number of memory options */
	for (i = 0; i < nLen; i++) {
		if (m_csMemUpgradeOptionsTotal.charAt(i) == ',') {
			/* Is this the right total? */
			if (nTotal == nIndex) {
				/* Yes, leave */
				i = csNumber;		/* Might have to do valueof */
				return i;
			}
			else {
				/* no, erase the number */
				csNumber = "";
			}
			nTotal++;
		}
		else {
			/* Save the Character */
			csNumber += m_csMemUpgradeOptionsTotal.charAt(i);
		}
	}
	/* No match */
	return 0;
}

function GetMemoryUpgradeValueByIndex(nIndex)
{
	var		nRet = 0;
	var		nSize = 0;

	nRet = 0;

	nSize = MemoryUpgradeArray.length;
	if (nSize <= 0 || nIndex >= nSize) {
		return nRet;
	}

	nRet = MemoryUpgradeArray[nIndex];
	return nRet;
}

function BuildMemoryUpgradeOptionText(nIndex)
{
	var			csBuild = "";
	var			nWantedMemorySize = 0;
	var			nOption = 0;
	var			nLen = 0;
	var			nTotal = 0;
	var			i = 0;
	var			nNum = 0;

	/* Get the Memory Size we need */
	nWantedMemorySize = GetMemoryUpgradeValueByIndex(nIndex);

	/* Find the total number of memory options */
	nLen = m_csMemUpgradeOptionsTotal.length;
	nTotal = 0;
	for (i = 0; i < nLen; i++) {
		if (m_csMemUpgradeOptionsTotal.charAt(i) == ',') {
			nTotal++;
		}
	}

	nOption = 0;
	csBuild = "";

	/* Merge the number of Meg with the text */
	csBuild = m_csTransTextTheseOptionsWill;
	csBuild = csBuild.replace("%d", nWantedMemorySize);
	csBuild += "<BR>";

	/* Search through the whole thing to find duplicates */
	for (i = 0; i < nTotal; i++) {
		nNum = GetMemoryUpgradeOptionsByIndex(i);
		if (nNum == nWantedMemorySize) {
			csBuild += "<BR>";
			nOption++;
			csBuild += GetMemoryUpgradeOptionTextByIndex(i, nOption);
		}
	}
	return csBuild;
}

function GetMemoryUpgradeOptionTextByIndex(nIndex, nOptionNumber)
{
	var			csOutput = "";
	var			csTemp = "";
	var			nSideType = 0;
	var			nStartAt = 0;
	var			nMatch = 0;

	/* Clear cBuffer */
	cBuffer = "";
	csOutput = "";

	/* Do we have any empty memory slots */
	if (m_nEmptySlots == 0) {
		/* No, just leave */
		csOutput = m_csNA;
		return csOutput;
	}

	csOutput = "<b>";
	csOutput += m_csTransTextOption;

	/* Convert the option number to text */
	csOutput += nOptionNumber;
	csOutput += ":</b><BR>";

/*****************/
/* Option Output */
/*****************/
	/* Setup nStartAt */
	/* Loop */
	for (var i = 0; i < m_dwMaxSlotSize.length; ++i)
	{
		nStartAt = 4;

		while (nStartAt <= m_dwMaxSlotSize[i])
		{
			nMatch = GetNumberOfMatchingOptions(nIndex, nStartAt);
			/* Any Matches */
			if (nMatch != 0) {
				/* Yes */
				csOutput += "&nbsp;&nbsp;&nbsp;&nbsp;";

				/* Add the 'add" text */
				csOutput += m_csTransTextAdd;
				csOutput += "&nbsp;";

				/* Convert number to text */
				csOutput += nMatch;

				csOutput += ",&nbsp;";

				/* Output the size of the memory module */
				csOutput += nStartAt;
				csOutput += m_csTransTextMegabyte;

				/* output the type of memory module */
				/* Find a used slot */
				for(var j = 0; j < m_nMemorySlots; j++) {
					if (m_dwSlotOptions[j] & MEMOPTIONEMPTY) {
						/* Is this the 1st Used Slot? */
						/* Save the memory module type */
						csOutput += DACCurrentMemoryType[j];
						if (0 < DACDeviceSpeeds[j])
						{
							csOutput += ", &nbsp;";
							csOutput += DACDeviceSpeeds[i];
							csOutput += "<str id=strMHz convert="$codesafe;">";
						}
						i = m_dwMaxSlotSize.length;
						break;
					}
				}


				csOutput += "<BR>";
			}
			nStartAt = (nStartAt * 2);
		}
	}


/***************/
/* Empty Slots */
/***************/

	/* Try to find matching empty Slots */
	nMatch = GetNumberOfMatchingOptions(nIndex, 0);
	csTemp = "";

	if (nMatch == 1) {
		/* Single */
		csTemp = m_csTransTextEmptyMemorySlotS;
		csTemp = csTemp.replace("%d", nMatch);
	}
	else if (nMatch == 0) {
		/* Zero */
		csTemp = m_csTransTextEmptyMemorySlot0;
		csTemp = csTemp.replace("%d", nMatch);
	}
	else {
		/* Plural */
		csTemp = m_csTransTextEmptyMemorySlotP;
		csTemp = csTemp.replace("%d", nMatch);
	}

	csOutput += "&nbsp;&nbsp;&nbsp;&nbsp;";
	csOutput += csTemp;
	csOutput += "<BR>";

	return csOutput;
}

function GetNumberOfMatchingOptions(nIndex, nMatch)
{
	var		i = 0;
	var		nLen = 0;
	var		nTotal = 0;
	var		csNum = "";
	var		nNum = 0;
	var		nValue = 0;
	var		nTotalMatch = 0;
	
	nTotal = 0;
	nTotalMatch = 0;
	csNum = "";

	/* Do we have any empty memory slots */
	if (m_nEmptySlots == 0) {
		/* No, just leave */
		return 0;
	}

	/* Get the length of m_csMemUpgradeOptions */
	nLen = m_csMemUpgradeOptions.length;

	/* Figure out the index value we need to search for */
	nValue = (nIndex * m_nEmptySlots);

	/* Is nValue 0? */
	if (nValue == 0) {
		i = 0;
		csNum = "";
		nTotal = 0;
//		for (i++; i < nLen; i++) {
		for (; i < nLen; i++) {
			/* Is this the comma? */
			if (m_csMemUpgradeOptions.charAt(i) == ',') {
				/* Yes */
				nTotal++;
				if (nTotal > m_nEmptySlots) {
					/* Leave */
					return nTotalMatch;
				}
				/* Is this a match? */
				if (csNum == nMatch) {
					/* Yes */
					nTotalMatch++;
				}
				csNum = "";
			}
			else {
				csNum += m_csMemUpgradeOptions.charAt(i);
			}
		}
		return nTotalMatch;
	}

	/* Find the total number of memory options */
	for (i = 0; i < nLen; i++) {
		if (m_csMemUpgradeOptions.charAt(i) == ',') {
			nTotal++;
			/* Is this the right Index? */
			if (nTotal >= nValue) {
				/* Yes, Now go through and get matches */
				csNum = "";
				nTotal = 0;
				for (i++; i < nLen; i++) {
					/* Is this the comma? */
					if (m_csMemUpgradeOptions.charAt(i) == ',') {
						/* Yes */
						nTotal++;
						if (nTotal > m_nEmptySlots) {
							/* Leave */
							return nTotalMatch;
						}
						/* Is this a match? */
						if (csNum == nMatch) {
							/* Yes */
							nTotalMatch++;
						}
						csNum = "";
					}
					else {
						csNum += m_csMemUpgradeOptions.charAt(i);
					}
				}
				return nTotalMatch;
			}
			csNum = "";
		}
		else {
			/* Write the character */
			csNum += m_csMemUpgradeOptions.charAt(i);
		}
	}
	return nTotalMatch;
}

</SCRIPT>

<SCRIPT>
function OutputMemoryUpgrade()
{
	var		nReturn;
	var		nOptions;
	var		i = 0;
	var		strReturnBuffer = "";
	var		strTemp1 = "";
	var		strTemp2 = "";

	/* Check for Instrumentation weirdness */
	if (DACMaxDIMMSize <= 0) {
		return(strReturnBuffer);
	}

	/* Setup the Memory Upgrade Variables */
	SetupMemoryVariables();

	/* Get the Number of Memory Upgrade Options */
	nOptions = GetNumberOfMemoryUpgradeOptions();
	if (nOptions == 0) {
		/* Nothing, just leave */
		return(strReturnBuffer);
	}

	/* Build a Sort Arrary */
	var		nSortArrayMemValue = new Array(nOptions);
	var		nSortArrayMemValueBackup = new Array(nOptions);
	var		nSortArrayMemIndex = new Array(nOptions);

	/* Build the Array */
	for (i = 0; i < nOptions; i++) {
		nSortArrayMemValue[i] = parseInt(GetMemoryUpgradeValueByIndex(i), 10);
		nSortArrayMemValueBackup[i] = parseInt(GetMemoryUpgradeValueByIndex(i), 10);
	}


	/* Sort The Array using the "SortPass" function */
	nSortArrayMemValue.sort(SortPass);

	/* Now fix the nSortArrayMemIndex array to reflet the sorted nSortArrayMemValue array */
	var	j = 0;
	do {
		for (i = 0; i < nOptions; i++) {
			if (nSortArrayMemValue[j] == nSortArrayMemValueBackup[i]) {
				nSortArrayMemIndex[j] = i;
				i = nOptions;		/* Break out */
			}
		}
		j++;
	} while (j < nOptions);

	/* Build the Table */
	strReturnBuffer += '<TABLE CLASS=ldcmWidth COLS=1 CELLPADDING=0 CELLSPACING=0 BORDER=1><TR BGCOLOR=#CCCCCC><TD>'

	/* Build a Drop down Combobox with the Memory Upgrade Options (Values) */
	strTemp2 = '<SELECT NAME="MemoryOptions" Size="1" ONCHANGE="ChangeMemoryOption()">\r\n';
	for (i = 0; i < nOptions; i++) {
		nReturn = nSortArrayMemValue[i];
		if (nReturn != 0) {
			strTemp2 += '<OPTION VALUE="';
			strTemp2 +=  nSortArrayMemIndex[i];
			strTemp2 += '">';

			/* Add the memory value text */
			strTemp2 += nReturn;

			/* Add space padding to make it bigger */
			strTemp2 += "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;\r\n";
		}

	}

	strTemp2 += '</SELECT>';

	/* Merge the combo box into the upgrade text */
	strTemp1 = m_csTransTextUpgradeThisComputer;
	strTemp1 = strTemp1.replace("%s", strTemp2);

	/* Add the Upgrade String with combo box */
	strReturnBuffer += strTemp1;

	strReturnBuffer += '<BR>';

	/* End the Cell and create a new Row */
	strReturnBuffer += '</TD></TR><TR><TD ID="MemoryOptionOutput">';

	/* Output the Memory Upgrade Option */
	/* Was the 1st item blank? */
	if (nSortArrayMemValue[0] == "") {
		/* Yes, Use the next one instead */
		nReturn = BuildMemoryUpgradeOptionText(nSortArrayMemIndex[1]);
	}
	else {
		/* No, Use the 1st one instead */
		nReturn = BuildMemoryUpgradeOptionText(nSortArrayMemIndex[0]);
	}

	if (nReturn != "") {
		strReturnBuffer += nReturn;
	}

	/* End the Table */
	strReturnBuffer += '</TD></TR></TABLE>';
	return(strReturnBuffer);
}

function ChangeMemoryOption()
{
	var		strReturnBuffer = "";
	var		strReturn = "";
	var		nIndex = 0;

	nIndex = MemoryOptions.value;

	/* Output the Memory Upgrade Option */
	strReturn = BuildMemoryUpgradeOptionText(nIndex);
	if (strReturn != "") {
		strReturnBuffer += strReturn;
	}

	MemoryOptionOutput.innerHTML = strReturnBuffer;
}

function SortPass(nItem1, nItem2)
{
	if (nItem1 < nItem2) {
		return -1;
	}
	else if (nItem1 == nItem2) {
		return 0;
	}
	return 1;
}


</SCRIPT>
